package com.zipcodewilmington.gildedrose;

import org.junit.Assert;
import org.junit.Test;

import java.sql.SQLOutput;

public class InventoryTest {


    Item genenetic = new Item("genetic item", 7, 25);
    Item ageBrie = new Item("Aged Brie", 7, 25);
    Item sulfuras = new Item("Sulfuras, Hand of Ragnaros", 15, 25);
    Item backStagePasses = new Item("Backstage passes to a TAFKAL80ETC concert", 11, 20);
    Item conjured = new Item("genetic item", 7, 25);
    Item[] items = {genenetic, ageBrie, sulfuras, backStagePasses, conjured};

    @Test
    public void updateQualityTest() {
        Inventory inventory = new Inventory(items);
        int before = items[0].getQuality();
        inventory.updateQuality();
        int after = items[0].getSellIn();
        Assert.assertTrue(before > after);


    }


    @Test
    public void updateQualityTest1() {
        Inventory inventory = new Inventory(items);
        int before = items[0].getQuality();
        inventory.updateQuality();
        int after = items[0].getQuality();
        Assert.assertTrue(before > after);


    }

    @Test
    public void updateQualityTest2() {
        Inventory inventory = new Inventory(items);

        for (int i = 0; i < 150; i++) {
            inventory.updateQuality();
        }

        int after = items[0].getQuality();
        //System.out.println(after);
        Assert.assertTrue(after >= 0);

    }


    @Test
    public void AgeBrieQualityIcrease() {
        Inventory inventory = new Inventory(items);
       items[1].setQuality(50);
        for (int i = 0; i < 150; i++) {
            inventory.updateQuality();
        }

        int after = items[1].getQuality();
        //System.out.println(after);

        //System.out.println(after);
        Assert.assertTrue(after > 0);

    }

    @Test
    public void AgeBrieQualityEqual50() {
        Inventory inventory = new Inventory(items);
        items[1].setQuality(0);
        for (int i = 0; i < 150; i++) {
            inventory.updateQuality();
        }
        int expected = 50;

        //System.out.println(after);
        Assert.assertEquals(expected, items[1].getQuality());

    }

    @Test
    public void testSufraQualityIcrease() {
        Inventory inventory = new Inventory(items);
        int before = items[2].getQuality();
        for (int i = 0; i < 150; i++) {
            inventory.updateQuality();
        }
        //quality stays the same
        int after = items[2].getQuality();
        // System.out.println(before); 25
        // System.out.println(after); 25
        Assert.assertTrue(after == before);

    }

    @Test
    public void testBackStagePasses10() {
        Inventory inventory = new Inventory(items);

        for (int i = 0; i < 10; i++) ;
        {
            inventory.updateQuality();
        }

        int expected = 21;
        Assert.assertEquals(expected, items[3].getQuality());
    }

    @Test
    public void testBackStagePasses5() {
        Inventory inventory = new Inventory(items);
        items[3].setSellIn(15);
        int before = items [3].getQuality();
        for (int i = 0; i < 150; i++) ;
        {
            inventory.updateQuality();
        }

        int after = items[3].getQuality();
        System.out.println(before);
        System.out.println(after);

        Assert.assertTrue(before < after);
    }
@Test
    public void getNameTest(){
        Inventory inventory = new Inventory(items);
        String expected = "Sulfuras, Hand of Ragnaros";
         Assert.assertEquals(expected, items [2].getName());
}
    @Test
    public void settNameTest(){
        Inventory inventory = new Inventory(items);
        items[0].setName("Sailor Moon");
        String expected = "Sailor Moon";
        Assert.assertEquals(expected, items [0].getName());
    }
}


